<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CategoriaEquipService;

class CategoriaEquipController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $CategoriaEquipService;
   
    public function __construct($crudService, $environment, CategoriaEquipService $CategoriaEquipService) {
        parent::__construct($crudService, $environment);
        $this->CategoriaEquipService = $CategoriaEquipService;
    }
    
    public function dadosCategoria(DTO\Request $request, DTO\Response $response) {
       $response->addDataSet(new DataSet('categoria', $this->CategoriaEquipService->dadosCategoria()));
    }
    
    public function categoria(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        if ($method== "POST") {
          $response->addDataSet(new DataSet('categoria', [$this->CategoriaEquipService->insertCategoria($request->getParameters())]));
        } else if ($method == "GET") {
           $response->addDataSet(new DataSet('categoria', $this->CategoriaEquipService->categoria()));
        }
       
    }
}

?>