import {
  IEventParam, IDictionary, Http,
} from '@zeedhi/core';
import {
  Modal, ModalService, Select,
} from '@zeedhi/common';

export class ModalController {
  private modalFuncionario!: Modal;

  public dataSelectsModal: IDictionary = {
    insOccupation: [],
    selectSector: [],
    selectShift: [],
  };

  public setDataModal(nome: string, cod: number) {
    return {
      name: nome,
      value: cod,
    };
  }

  public setOccupation() {
    Http.get('/getOccupation').then((response: IDictionary) => {
      response.data.dataset.occupation.forEach((dados: IDictionary) => {
        this.dataSelectsModal.insOccupation.push(this.setDataModal(dados.NMHABILIDADE, dados.NRHABILIDADE));
      });
    });
  }

  public setSector() {
    Http.get('/getSectorEmployee').then((response: IDictionary) => {
      response.data.dataset.sector.forEach((dados: IDictionary) => {
        this.dataSelectsModal.selectSector.push(this.setDataModal(dados.NMSETOR, dados.NRSETOR));
      });
    });
  }

  public initializeDataModal() {
    this.setOccupation();
    this.setSector();
  }

  public getDataInfoModal({ component }: IEventParam<Select>) {
    component.datasource.data = this.dataSelectsModal[component.name];
  }

  public async createmodalFuncionario() {
    this.modalFuncionario = await ModalService.createFromJson('/modal/modalNovoFuncionario', true);
  }

  public destroymodalFuncionario() {
    this.modalFuncionario.destroy();
  }

  public openmodalFuncionario() {
    this.modalFuncionario.show();
  }

  public closemodalFuncionario() {
    this.modalFuncionario.hide();
  }
}
