/* eslint-disable */
import {
  Metadata, Http, IDictionary,
  IEventParam, Loader,
} from '@zeedhi/core';
import {
  Button, Select, Text, IComponentRender, Date as dateInput,
} from '@zeedhi/common';
import { IterableComponentRender } from '@zeedhi/teknisa-components-common';

export class TarefaController {
  public hierarquiasController = Loader.getInstance('HierarquiasController');

  // Controlla a visibilidade do botão 'Nova Tarefa'
  public isVisibleElement: boolean = !(localStorage.getItem('idpermissstarefas') === 'V');

  private dadosOriginal: IDictionary = {};

  public proximaPagina({ component }: any) {
    component.parent.datasource.page += 1;
    if (component.parent.paginationLength === component.parent.datasource.page) {
      component.disabled = true;
    }
    component.parent.datasource.get();
    Metadata.getInstance<Button>(`BotaoPaginaAnterior_${component.name.split('_')[1]}`).disabled = false;
  }

  public paginaAnterior({ component }: any) {
    if (component.parent.datasource.page > 1) {
      component.parent.datasource.page -= 1;
      if (component.parent.datasource.page === 1) {
        component.disabled = true;
      }
      component.parent.datasource.get();
      Metadata.getInstance<Button>(`BotaoProximaPagina_${component.name.split('_')[1]}`).disabled = false;
    }
  }

  public MaisQueUmaPagina({ component }: any) {
    component.disabled = !(Metadata.getInstance<IterableComponentRender>(component.name.split('_')[1]).paginationLength > 1);
  }

  public async getTarefas(){
    const hierarchyUsersList: IDictionary = await this.hierarquiasController.mountHierarchyUsersArray();
    const iterable = Metadata.getInstance<IterableComponentRender>('iterable-Card-Task');
    iterable.datasource.data = [];
    Http.post('/getCard', hierarchyUsersList).then((resposta: IDictionary) => {
      const dadosBanco = resposta.data.dataset.cards;
      dadosBanco.forEach((elemento: any, pos: number) => {
        if (dadosBanco[pos].NMIDSITUACAOAGEND === 'Pendente') {
          dadosBanco[pos].COR = "#ff6700";
        } else if (dadosBanco[pos].NMIDSITUACAOAGEND === 'Em Andamento') {
          dadosBanco[pos].COR = "#023e8a";
        } else if (dadosBanco[pos].NMIDSITUACAOAGEND === 'Concluido') {
          dadosBanco[pos].COR = "#2b9348";
        } else {
          dadosBanco[pos].COR = "#FA980D";
        }
      });
      const tarefas = dadosBanco.map((dados: any) => dados.NMCHECKLISTAGEND);
      Metadata.getInstance<Select>('CampoParaFiltrar_iterable-Card-Task_NMCHECKLISTAGEND').updateItems(tarefas.filter((nome: string, pos: number) => tarefas.indexOf(nome) === pos));
      const local = (dadosBanco.map((dados: any) => dados.NMLOCAL.split(' | '))).flat(1);
      Metadata.getInstance<Select>('CampoParaFiltrar_iterable-Card-Task_NMLOCAL').updateItems(local.filter((nome: string, pos: number) => local.indexOf(nome) === pos));
      const checklist = dadosBanco.map((dados: any) => dados.NMCHECKLIST);
      Metadata.getInstance<Select>('CampoParaFiltrar_iterable-Card-Task_NMCHECKLIST').updateItems(checklist.filter((nome: string, pos: number) => checklist.indexOf(nome) === pos));
      const situacao = dadosBanco.map((dados: any) => dados.NMIDSITUACAOAGEND);
      Metadata.getInstance<Select>('CampoParaFiltrar_iterable-Card-Task_NMIDSITUACAOAGEND').updateItems(situacao.filter((nome: string, pos: number) => situacao.indexOf(nome) === pos));
      const funcionario = dadosBanco.map((dados: any) => dados.NMFUNCIONARIO);
      Metadata.getInstance<Select>('CampoParaFiltrar_iterable-Card-Task_NMFUNCIONARIO').updateItems(funcionario.filter((nome: string, pos: number) => funcionario.indexOf(nome) === pos));
      
      iterable.datasource.updateData(dadosBanco);
      this.dadosOriginal['iterable-Card-Task'] = dadosBanco;
      this.MaisQueUmaPagina({ component: Metadata.getInstance<Button>('BotaoProximaPagina_iterable-Card-Task') });
    });
  }

  public filter({ component }: any) {
    const iterable = Metadata.getInstance<IterableComponentRender>('iterable-Card-Task');
    console.log(component.value);
    if (component.value) {
      const filtro: any = iterable.datasource.filter;
      filtro[component.name.split('_')[2]] = component.value;
      iterable.datasource.setFilter(filtro)
    } else {
      iterable.datasource.removeFilter(component.name.split('_')[2]);
    }
    this.MaisQueUmaPagina({ component: Metadata.getInstance<Button>(`BotaoProximaPagina_${component.name.split('_')[1]}`) });
  }
}